#include <iostream>
using namespace std;
int main()
{
    int n,k,x;
    cin>>n>>k>>x;
    if(k==3)
    {
        int brojac=0;
        if(3+(n-1)*(x+1)>1000000)
            cout<<-1;
        else
        for(int i=1;i<=n;i+=x+1)
        {
            if(brojac!=3)
            {
                cout<<"1 2 3";
                i=3;
                brojac++;
            }
            i+=x+1;
            cout<<i<<" ";
        }
    }
    
}